package org.greenstone.gsdl3_extension.mat;

import java.awt.Toolkit;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import java.awt.Dimension;

public class MainApplication {
    boolean packFrame = false;

    
    public MainApplication(){}
    
    public MainApplication(String collectionName) {
    	
	DescribeMessenger dm = new DescribeMessenger(collectionName," ");
    	MainApplication ma = new MainApplication ();
    	ma.start(dm, collectionName);
    }

    public void start(DescribeMessenger dm, String collectionName){
    	
	dm.describeMatadata(collectionName,"");

	MainApplicationFrame frame = new MainApplicationFrame(dm.getElementClass());
	
        if (packFrame) {
            frame.pack();
        } else {
            frame.validate();
        }
	
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        Dimension frameSize = frame.getSize();
        
	if (frameSize.height > screenSize.height) {
            frameSize.height = screenSize.height;
        }
        if (frameSize.width > screenSize.width) {
            frameSize.width = screenSize.width;
        }
        frame.setLocation((screenSize.width - frameSize.width) / 2,
                          (screenSize.height - frameSize.height) / 2);
        frame.setVisible(true);
    }
    
    public static void main(String[] args) {
    	String collectionName = args[0];
        new MainApplication(collectionName);
    }
}
