package org.greenstone.gsdl3_extension.mat.servlet;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

public class SearchLink {

	private String path = "";
	private boolean status = true;
    protected final String DocumentNode = "Document";
    protected final String ActualValueNode = "ActualValue";
	
	public SearchLink(String arg1){
		path = arg1;
	}
	
	public SearchLink(){}
	
	public boolean getStatus(){
		return status;
	}
	
	public ArrayList CreateIndentifierLinkPage(String metadataElement, String text, String identifier, String col, HashMap valueMap, HashMap linkMap){

		if(valueMap.size()==0){
			status = false;
			return new ArrayList();
		}
		else{
			ArrayList alist = retrieveHASHID(valueMap,text);
			if(alist.size()==0){
				status = false;
				return new ArrayList();
			}

			if(linkMap.size()==0){	
				status = false;
				return new ArrayList();
			}
			else{
			ArrayList alist2 = retrieveHASHID(linkMap,alist);
			return alist2;
			}
		}
	}
	
	
	private Element openfile(String core_element, String collection){
		
		try{
			DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		    DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
		    Document doc = docBuilder.newDocument();
		  
		    doc = docBuilder.parse (new File(path+core_element+".xml"));
		    Element rootNode = doc.getDocumentElement();
		    return rootNode;  
		    }catch (Exception e) {
		    	System.out.println(core_element + " does not exist");
	    	    return null;
		    }
	}
	
	private ArrayList retrieveHASHID (HashMap hp, String text){
	    if(hp.containsKey(text)){
	    	InternalLink il = (InternalLink) hp.get(text);
	    	return il.retrieveList();
	    }
	    else{
	    	return new ArrayList();
	    }
	}
	
	private ArrayList retrieveHASHID (HashMap hp, ArrayList arg){
     
		ArrayList alist = new ArrayList();
		for(int i = 0; i<arg.size(); i++){
			String text = (String)arg.get(i);
			if(hp.containsKey(text)){
				InternalLink il = (InternalLink) hp.get(text);
				ArrayList arrayList = il.retrieveList();
				if(arrayList.size()!=0){
					alist.add(il.retrieveList().get(0));
				}
				else{
					alist.add("&nbsp;");
				}
			}
		}
		return alist;
	}

	public HashMap createValueMap(String core_element, String collection){

 	HashMap hp = new HashMap();
 	Element ex = openfile(core_element,collection);
  	NodeList valueList = ex.getElementsByTagName(ActualValueNode);
  	
    for(int s=0; s<valueList.getLength() ; s++){
      	   Element docNode = (Element)valueList.item(s);
      	   NodeList NodeIDMap = docNode.getChildNodes();
      	   Node DocNodeID = NodeIDMap.item(0);
      	   String actualValue = DocNodeID.getNodeValue();
      	   String DocID = DocNodeID.getParentNode().getParentNode().getAttributes().item(0).getNodeValue();
  		 
      	   if(hp.containsKey(actualValue)){
      		 InternalLink il = (InternalLink) hp.get(actualValue);
      		 il.increaseElement(DocID);
      		 hp.put(actualValue, il);
      	   }
      	   else{
      		   InternalLink il = new InternalLink();
      		   il.setValue(actualValue);
      		   il.increaseElement(DocID);
      		   hp.put(actualValue, il);
      	   }
    	}

    return hp;
	}

	
	public HashMap createLinkMap (String core_element, String collection){

		HashMap hp = new HashMap();
		Element ex = openfile(core_element,collection);
      	NodeList listOfFrequency = ex.getElementsByTagName(DocumentNode);
      	
      	if(listOfFrequency.getLength()==0){
      		return hp;
      	}
      	
      	for(int s=0; s<listOfFrequency.getLength() ; s++){
      	   Node docNode = listOfFrequency.item(s);
      	   NamedNodeMap NodeIDMap = docNode.getAttributes();
      	   Node DocNodeID = NodeIDMap.item(0);
      	   String DocID = DocNodeID.getNodeValue();


      	   if(hp.containsKey(DocID)){

      		   Element xNode = (Element)docNode;
          	   NodeList valueList = xNode.getElementsByTagName(ActualValueNode);
          	   
          	   ArrayList alist = new ArrayList();
          	   for(int y = 0; y<valueList.getLength(); y++){
          		   Element valueElement = (Element)valueList.item(y);
          		   NodeList textFNList = valueElement.getChildNodes();
          		   String textValue = ((Node)textFNList.item(0)).getNodeValue();

          		   if(textValue.startsWith("http://")){
          			 InternalLink il = (InternalLink)hp.get(DocID);
          			 il.increaseElement(textValue);
          			 break;
          		   }
       		    }
      	   }
      	   
      	   
      	   else {
      		   InternalLink il = new InternalLink();
      		   il.setValue(DocID);
      		   
    		   Element xNode = (Element)docNode;
          	   NodeList valueList = xNode.getElementsByTagName(ActualValueNode);
          	   
          	   for(int y = 0; y<valueList.getLength(); y++){
          		   Element valueElement = (Element)valueList.item(y);
          		   NodeList textFNList = valueElement.getChildNodes();
          		   String textValue = ((Node)textFNList.item(0)).getNodeValue();

          		   if(textValue.startsWith("http://")){
          			 il.increaseElement(textValue);
          			 break;
          		   }
       		    }
          	   hp.put(DocID, il);
      	   }
        }
		return hp;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	////////////////////////////////////////////////////////////////////////////////////////////////////////////
}
